Index: /palm/trunk/SOURCE/restart_data_mpi_io_mod.f90
===================================================================
--- /palm/trunk/SOURCE/restart_data_mpi_io_mod.f90	(revision 4590)
+++ /palm/trunk/SOURCE/restart_data_mpi_io_mod.f90	(revision 4591)
@@ -1,4 +1,4 @@
 !> @file restart_data_mpi_io_mod.f90
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! This file is part of the PALM model system.
 !
@@ -15,38 +15,43 @@
 !
 ! Copyright 1997-2020 Leibniz Universitaet Hannover
-! -------------------------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
+!
 !
 ! Current revisions:
 ! -----------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
-! checks added, if index limits in header are exceeded
-! bugfix in rrd_mpi_io_int_2d
-! 
+! File re-formatted to follow the PALM coding standard
+!
+!
+! 4539 2020-05-18 14:05:17Z raasch
+! Checks added, if index limits in header are exceeded
+! Bugfix in rrd_mpi_io_int_2d
+!
 ! 4536 2020-05-17 17:24:13Z raasch
-! messages and debug output converted to PALM routines
-! 
+! Messages and debug output converted to PALM routines
+!
 ! 4534 2020-05-14 18:35:22Z raasch
 ! I/O on reduced number of cores added (using shared memory MPI)
-! 
+!
 ! 4500 2020-04-17 10:12:45Z suehring
 ! Fix too long lines
-! 
+!
 ! 4498 2020-04-15 14:26:31Z raasch
-! bugfix for creation of filetypes, argument removed from rd_mpi_io_open
-! 
+! Bugfix for creation of filetypes, argument removed from rd_mpi_io_open
+!
 ! 4497 2020-04-15 10:20:51Z raasch
-! last bugfix deactivated because of compile problems
-! 
+! Last bugfix deactivated because of compile problems
+!
 ! 4496 2020-04-15 08:37:26Z raasch
-! problem with posix read arguments for surface data fixed
-! 
+! Problem with posix read arguments for surface data fixed
+!
 ! 4495 2020-04-13 20:11:20Z raasch
 ! Initial version (K. Ketelsen), adjusted to PALM formatting standards (s. Raasch)
 !
-! 
+!
 !
 ! Description:
@@ -64,5 +69,9 @@
 #else
     USE posix_interface,                                                                           &
-        ONLY:  posix_close, posix_lseek, posix_open, posix_read, posix_write
+        ONLY:  posix_close,                                                                        &
+               posix_lseek,                                                                        &
+               posix_open,                                                                         &
+               posix_read,                                                                         &
+               posix_write
 #endif
 
@@ -70,26 +79,56 @@
 
     USE control_parameters,                                                                        &
-        ONLY:  debug_output, debug_string, include_total_domain_boundaries, message_string,        &
-               restart_data_format_input, restart_data_format_output, restart_file_size
+        ONLY:  debug_output,                                                                       &
+               debug_string,                                                                       &
+               include_total_domain_boundaries,                                                    &
+               message_string,                                                                     &
+               restart_data_format_input,                                                          &
+               restart_data_format_output,                                                         &
+               restart_file_size
 
     USE exchange_horiz_mod,                                                                        &
-        ONLY:  exchange_horiz, exchange_horiz_2d
+        ONLY:  exchange_horiz,                                                                     &
+               exchange_horiz_2d
 
     USE indices,                                                                                   &
-        ONLY:  nbgp, nnx, nny, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nz, nzb, nzt
+        ONLY:  nbgp,                                                                               &
+               nnx,                                                                                &
+               nny,                                                                                &
+               nx,                                                                                 &
+               nxl,                                                                                &
+               nxlg,                                                                               &
+               nxr,                                                                                &
+               nxrg,                                                                               &
+               ny,                                                                                 &
+               nyn,                                                                                &
+               nyng,                                                                               &
+               nys,                                                                                &
+               nysg,                                                                               &
+               nz,                                                                                 &
+               nzb,                                                                                &
+               nzt
 
     USE kinds
 
     USE pegrid,                                                                                    &
-        ONLY:  comm1dx, comm1dy, comm2d, myid, myidx, myidy, npex, npey, numprocs, pdims
+        ONLY:  comm1dx,                                                                            &
+               comm1dy,                                                                            &
+               comm2d,                                                                             &
+               myid,                                                                               &
+               myidx,                                                                              &
+               myidy,                                                                              &
+               npex,                                                                               &
+               npey,                                                                               &
+               numprocs,                                                                           &
+               pdims
 
     USE shared_memory_io_mod,                                                                      &
-        ONLY:  local_boundaries, sm_class
-
-
-    IMPLICIT NONE
-
-    CHARACTER(LEN=128) :: io_file_name  !> internal variable to communicate filename between
-                                        !> different subroutines
+        ONLY:  local_boundaries,                                                                   &
+               sm_class
+
+
+    IMPLICIT NONE
+
+    CHARACTER(LEN=128) ::  io_file_name  !> internal variable to communicate filename between different subroutines
 
 #if defined( __parallel )
@@ -99,35 +138,35 @@
 #else
     INTEGER(iwp), PARAMETER ::  rd_offset_kind = C_SIZE_T         !<
-    INTEGER(iwp), PARAMETER ::  rd_status_size = 1       !< Not required in sequential mode
-#endif
-
-    INTEGER(iwp)            ::  debug_level = 1 !< TODO: replace with standard debug output steering
-
-    INTEGER(iwp)            ::  comm_io       !< Communicator for MPI-IO
-    INTEGER(iwp)            ::  fh            !< MPI-IO file handle
-#if defined( __parallel )
-    INTEGER(iwp)            ::  fhs = -1      !< MPI-IO file handle to open file with comm2d always
-#endif
-    INTEGER(iwp)            ::  ft_surf = -1  !< MPI filetype surface data
-#if defined( __parallel )
-    INTEGER(iwp)            ::  ft_2di_nb     !< MPI filetype 2D array INTEGER no outer boundary
-    INTEGER(iwp)            ::  ft_2d         !< MPI filetype 2D array REAL with outer boundaries
-    INTEGER(iwp)            ::  ft_3d         !< MPI filetype 3D array REAL with outer boundaries
-    INTEGER(iwp)            ::  ft_3dsoil     !< MPI filetype for 3d-soil array
-#endif
-    INTEGER(iwp)            ::  glo_start     !< global start index on this PE
-#if defined( __parallel )
-    INTEGER(iwp)            ::  local_start   !<
-#endif
-    INTEGER(iwp)            ::  nr_iope       !<
-    INTEGER(iwp)            ::  nr_val        !< local number of values in x and y direction
-#if defined( __parallel )
-    INTEGER(iwp)            ::  win_2di
-    INTEGER(iwp)            ::  win_2dr
-    INTEGER(iwp)            ::  win_3dr
-    INTEGER(iwp)            ::  win_3ds
-    INTEGER(iwp)            ::  win_surf = -1
-#endif
-    INTEGER(iwp)            ::  total_number_of_surface_values    !< total number of values for one variable
+    INTEGER(iwp), PARAMETER ::  rd_status_size = 1                !< Not required in sequential mode
+#endif
+
+    INTEGER(iwp)            ::  debug_level = 1  !< TODO: replace with standard debug output steering
+
+    INTEGER(iwp)            ::  comm_io          !< Communicator for MPI-IO
+    INTEGER(iwp)            ::  fh               !< MPI-IO file handle
+#if defined( __parallel )
+    INTEGER(iwp)            ::  fhs = -1         !< MPI-IO file handle to open file with comm2d always
+#endif
+    INTEGER(iwp)            ::  ft_surf = -1     !< MPI filetype surface data
+#if defined( __parallel )
+    INTEGER(iwp)            ::  ft_2di_nb        !< MPI filetype 2D array INTEGER no outer boundary
+    INTEGER(iwp)            ::  ft_2d            !< MPI filetype 2D array REAL with outer boundaries
+    INTEGER(iwp)            ::  ft_3d            !< MPI filetype 3D array REAL with outer boundaries
+    INTEGER(iwp)            ::  ft_3dsoil        !< MPI filetype for 3d-soil array
+#endif
+    INTEGER(iwp)            ::  glo_start        !< global start index on this PE
+#if defined( __parallel )
+    INTEGER(iwp)            ::  local_start      !<
+#endif
+    INTEGER(iwp)            ::  nr_iope          !<
+    INTEGER(iwp)            ::  nr_val           !< local number of values in x and y direction
+#if defined( __parallel )
+    INTEGER(iwp)            ::  win_2di          !<
+    INTEGER(iwp)            ::  win_2dr          !<
+    INTEGER(iwp)            ::  win_3dr          !<
+    INTEGER(iwp)            ::  win_3ds          !<
+    INTEGER(iwp)            ::  win_surf = -1    !<
+#endif
+    INTEGER(iwp)            ::  total_number_of_surface_values  !< total number of values for one variable
 
     INTEGER(KIND=rd_offset_kind) ::  array_position   !<
@@ -137,12 +176,13 @@
 
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  m_end_index     !<
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  m_global_start  !<
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  m_start_index   !<
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  m_global_start  !<
-
-    LOGICAL ::  all_pes_write                     !< all PEs have data to write
-    LOGICAL ::  filetypes_created                 !<
-    LOGICAL ::  io_on_limited_cores_per_node      !< switch to shared memory MPI-IO
-    LOGICAL ::  rd_flag                           !< file is opened for read
-    LOGICAL ::  wr_flag                           !< file is opened for write
+
+
+    LOGICAL ::  all_pes_write                 !< all PEs have data to write
+    LOGICAL ::  filetypes_created             !<
+    LOGICAL ::  io_on_limited_cores_per_node  !< switch to shared memory MPI-IO
+    LOGICAL ::  rd_flag                       !< file is opened for read
+    LOGICAL ::  wr_flag                       !< file is opened for write
 
 #if defined( __parallel )
@@ -160,17 +200,17 @@
 !-- General Header (first 32 byte in restart file)
     TYPE general_header
+       INTEGER(iwp) :: endian         !< little endian (1) or big endian (2) internal format
+       INTEGER(iwp) :: i_outer_bound  !< if 1, outer boundaries are stored in restart file
+       INTEGER(iwp) :: nr_arrays      !< number of arrays in restart files
+       INTEGER(iwp) :: nr_char        !< number of Text strings entries in header
        INTEGER(iwp) :: nr_int         !< number of INTEGER entries in header
-       INTEGER(iwp) :: nr_char        !< number of Text strings entries in header
        INTEGER(iwp) :: nr_real        !< number of REAL entries in header
-       INTEGER(iwp) :: nr_arrays      !< number of arrays in restart files
        INTEGER(iwp) :: total_nx       !< total number of points in x-direction
        INTEGER(iwp) :: total_ny       !< total number of points in y-direction
-       INTEGER(iwp) :: i_outer_bound  !< if 1, outer boundaries are stored in restart file
-       INTEGER(iwp) :: endian         !< little endian (1) or big endian (2) internal format
     END TYPE general_header
 
-    TYPE(general_header), TARGET ::  tgh
-
-    TYPE(sm_class)               ::  sm_io
+    TYPE(general_header), TARGET ::  tgh    !<
+
+    TYPE(sm_class)               ::  sm_io  !<
 
 !
@@ -194,5 +234,4 @@
     CHARACTER(LEN=32), DIMENSION(max_nr_arrays) ::  array_names
     INTEGER(KIND=rd_offset_kind), DIMENSION(max_nr_arrays) :: array_offset
-
     SAVE
 
@@ -267,7 +306,14 @@
     END INTERFACE wrd_mpi_io_surface
 
-    PUBLIC  rd_mpi_io_check_array, rd_mpi_io_close, rd_mpi_io_open, rrd_mpi_io,                    &
-            rrd_mpi_io_global_array, rrd_mpi_io_surface, rd_mpi_io_surface_filetypes, wrd_mpi_io,  &
-            wrd_mpi_io_global_array, wrd_mpi_io_surface
+    PUBLIC  rd_mpi_io_check_array,                                                                 &
+            rd_mpi_io_close,                                                                       &
+            rd_mpi_io_open,                                                                        &
+            rrd_mpi_io,                                                                            &
+            rrd_mpi_io_global_array,                                                               &
+            rrd_mpi_io_surface,                                                                    &
+            rd_mpi_io_surface_filetypes,                                                           &
+            wrd_mpi_io,                                                                            &
+            wrd_mpi_io_global_array,                                                               &
+            wrd_mpi_io_surface
 
 
@@ -284,21 +330,21 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN)  ::  action                           !<
-    CHARACTER(LEN=*), INTENT(IN)  ::  file_name                        !<
-
-    INTEGER(iwp)                  ::  i                                !<
-    INTEGER(iwp)                  ::  gh_size                          !<
-
-    INTEGER(KIND=rd_offset_kind)  ::  offset                           !<
-
-#if defined( __parallel )
-    INTEGER, DIMENSION(rd_status_size) ::  status                      !<
-#endif
-
-    LOGICAL, INTENT(IN), OPTIONAL ::  open_for_global_io_only          !<
-    LOGICAL                       ::  set_filetype                     !<
+    CHARACTER(LEN=*), INTENT(IN) ::  action     !<
+    CHARACTER(LEN=*), INTENT(IN) ::  file_name  !<
+
+    INTEGER(iwp)                 ::  i          !<
+    INTEGER(iwp)                 ::  gh_size    !<
+
+    INTEGER(KIND=rd_offset_kind) ::  offset     !<
+
+#if defined( __parallel )
+    INTEGER, DIMENSION(rd_status_size) ::  status  !<
+#endif
+
+    LOGICAL, INTENT(IN), OPTIONAL ::  open_for_global_io_only  !<
+    LOGICAL                       ::  set_filetype             !<
 
 #if ! defined( __parallel )
-    TYPE(C_PTR)                   ::  buf_ptr                          !<
+    TYPE(C_PTR)                   ::  buf_ptr  !<
 #endif
 
@@ -377,5 +423,5 @@
 
           IF ( ierr /= 0 )  THEN
-             message_string = 'error opening restart file "' // TRIM( io_file_name ) //      &
+             message_string = 'error opening restart file "' // TRIM( io_file_name ) //            &
                               '" for reading with MPI-IO'
              CALL message( 'rrd_mpi_io_open', 'PA0727', 3, 2, 0, 6, 0 )
@@ -400,5 +446,5 @@
 
           IF ( ierr /= 0 )  THEN
-             message_string = 'error opening restart file "' // TRIM( io_file_name ) //      &
+             message_string = 'error opening restart file "' // TRIM( io_file_name ) //            &
                               '" for writing with MPI-IO'
              CALL message( 'rrd_mpi_io_open', 'PA0728', 3, 2, 0, 6, 0 )
@@ -418,5 +464,5 @@
 
        IF ( debug_output )  THEN
-          WRITE( debug_string, * )  'open restart file "' // TRIM( io_file_name ) //            &
+          WRITE( debug_string, * )  'open restart file "' // TRIM( io_file_name ) //               &
                                     '" for read in serial mode (posix)'
           CALL debug_message( debug_string, 'start' )
@@ -426,5 +472,5 @@
 
        IF ( debug_output )  THEN
-          WRITE( debug_string, * )  'open restart file "' // TRIM( io_file_name ) //            &
+          WRITE( debug_string, * )  'open restart file "' // TRIM( io_file_name ) //               &
                                     '" for read in serial mode (posix)'
           CALL debug_message( debug_string, 'end' )
@@ -434,5 +480,5 @@
 
        IF ( debug_output )  THEN
-          WRITE( debug_string, * )  'open restart file "' // TRIM( io_file_name ) //            &
+          WRITE( debug_string, * )  'open restart file "' // TRIM( io_file_name ) //               &
                                     '" for write in serial mode (posix)'
           CALL debug_message( debug_string, 'start' )
@@ -442,5 +488,5 @@
 
        IF ( debug_output )  THEN
-          WRITE( debug_string, * )  'open restart file "' // TRIM( io_file_name ) //            &
+          WRITE( debug_string, * )  'open restart file "' // TRIM( io_file_name ) //               &
                                     '" for write in serial mode (posix)'
           CALL debug_message( debug_string, 'end' )
@@ -479,5 +525,5 @@
     header_int_index = header_int_index+3
 
-    DO   i = 1, max_nr_arrays
+    DO  i = 1, max_nr_arrays
        array_offset(i) = 0
        array_names(i)  = ' '
@@ -489,5 +535,5 @@
        IF ( sm_io%iam_io_pe )  THEN
 !
-!--       File is open for read.
+!--       File is open for reading
 #if defined( __parallel )
 !--       Set the default view
@@ -513,5 +559,5 @@
 
 !
-!--    File types depend on if boundaries of the total domain is included in data. This has been
+!--    File types depend on boundaries of the total domain being included in data. This has been
 !--    checked with the previous statement.
        IF ( set_filetype )  THEN
@@ -535,5 +581,5 @@
           CALL MPI_FILE_SEEK( fh, header_position, MPI_SEEK_SET, ierr )
           CALL MPI_FILE_READ( fh, text_lines, SIZE( text_lines ) * 128, MPI_CHAR, status, ierr )
-          header_position = header_position+size(text_lines) * 128
+          header_position = header_position + SIZE ( text_lines ) * 128
 !
 !--       REAL values
@@ -640,5 +686,5 @@
     INTEGER(iwp) ::  i  !<
 
-    LOGICAl      ::  found  !<
+    LOGICAl ::  found  !<
 
 
@@ -666,10 +712,10 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN)   :: name
-
-    INTEGER(iwp)                   ::  i
-    INTEGER(KIND=iwp), INTENT(OUT) ::  value
-
-    LOGICAL                        ::  found
+    CHARACTER(LEN=*), INTENT(IN) :: name  !<
+
+    INTEGER(iwp)                   ::  i      !<
+    INTEGER(KIND=iwp), INTENT(OUT) ::  value  !<
+
+    LOGICAL ::  found  !<
 
 
@@ -703,11 +749,11 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN)   ::  name
-
-    INTEGER(iwp)                   ::  i
-
-    LOGICAL                        ::  found
-
-    REAL(KIND=wp), INTENT(OUT)     ::  value
+    CHARACTER(LEN=*), INTENT(IN) ::  name   !<
+
+    INTEGER(iwp)                 ::  i      !<
+
+    LOGICAL                      ::  found  !<
+
+    REAL(KIND=wp), INTENT(OUT)   ::  value  !<
 
 
@@ -741,14 +787,14 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN)       ::  name
-
-#if defined( __parallel )
-    INTEGER, DIMENSION(rd_status_size) ::  status
-#endif
-    INTEGER(iwp)                       ::  i
-
-    LOGICAL                            ::  found
-
-    REAL(wp), INTENT(INOUT), DIMENSION(nysg:nyng,nxlg:nxrg) ::  data
+    CHARACTER(LEN=*), INTENT(IN)       ::  name    !<
+
+#if defined( __parallel )
+    INTEGER, DIMENSION(rd_status_size) ::  status  !<
+#endif
+    INTEGER(iwp)                       ::  i       !<
+
+    LOGICAL                            ::  found   !<
+
+    REAL(wp), INTENT(INOUT), DIMENSION(nysg:nyng,nxlg:nxrg) ::  data  !<
 
 
@@ -765,7 +811,7 @@
     IF ( found )  THEN
 #if defined( __parallel )
-       CALL sm_io%sm_node_barrier()  ! has no effect if I/O on limited number of cores is inactive
+       CALL sm_io%sm_node_barrier()  ! Has no effect if I/O on limited number of cores is inactive
        IF ( sm_io%iam_io_pe )  THEN
-          CALL MPI_FILE_SET_VIEW( fh, array_position, MPI_REAL, ft_2d, 'native', MPI_INFO_NULL,   &
+          CALL MPI_FILE_SET_VIEW( fh, array_position, MPI_REAL, ft_2d, 'native', MPI_INFO_NULL,    &
                                   ierr )
           CALL MPI_FILE_READ_ALL( fh, array_2d, SIZE( array_2d ), MPI_REAL, status, ierr )
@@ -809,16 +855,16 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN)        ::  name
-
-    INTEGER(iwp)                        ::  i
-    INTEGER(iwp)                        ::  j
-
-#if defined( __parallel )
-    INTEGER, DIMENSION(rd_status_size)  ::  status
-#endif
-
-    INTEGER(KIND=iwp), INTENT(INOUT), DIMENSION(:,:) ::  data
-
-    LOGICAL                             ::  found
+    CHARACTER(LEN=*), INTENT(IN)       ::  name    !<
+
+    INTEGER(iwp)                       ::  i       !<
+    INTEGER(iwp)                       ::  j       !<
+
+#if defined( __parallel )
+    INTEGER, DIMENSION(rd_status_size) ::  status  !<
+#endif
+
+    INTEGER(KIND=iwp), INTENT(INOUT), DIMENSION(:,:) ::  data  !<
+
+    LOGICAL ::  found  !<
 
 
@@ -835,9 +881,9 @@
     IF ( found )  THEN
 
-       IF ( ( nxr - nxl + 1 + 2*nbgp ) == SIZE( data, 2 ) )  THEN
+       IF ( ( nxr - nxl + 1 + 2 * nbgp ) == SIZE( data, 2 ) )  THEN
 !
 !--       Output array with Halos.
-!--       ATTENTION: INTEGER array with ghost boundaries are not implemented yet. This kind of array
-!--                  would be dimensioned in the caller subroutine like this:
+!--       ATTENTION: INTEGER arrays with ghost boundaries are not implemented yet. This kind of
+!--                  array would be dimensioned in the caller subroutine like this:
 !--                  INTEGER, DIMENSION(nysg:nyng,nxlg:nxrg)::  data
           message_string = '2d-INTEGER array "' // TRIM( name ) // '" to be read from restart ' // &
@@ -845,5 +891,5 @@
           CALL message( 'rrd_mpi_io_int_2d', 'PA0723', 3, 2, 0, 6, 0 )
 
-       ELSEIF ( (nxr-nxl+1) == SIZE( data, 2 ) )  THEN
+       ELSEIF ( (nxr - nxl + 1) == SIZE( data, 2 ) )  THEN
 !
 !--       INTEGER input array without Halos.
@@ -852,5 +898,5 @@
 
 #if defined( __parallel )
-          CALL sm_io%sm_node_barrier() ! has no effect if I/O on limited number of cores is inactive
+          CALL sm_io%sm_node_barrier() ! Has no effect if I/O on limited number of cores is inactive
           IF ( sm_io%iam_io_pe )  THEN
              CALL MPI_FILE_SET_VIEW( fh, array_position, MPI_INTEGER, ft_2di_nb, 'native',         &
@@ -898,15 +944,15 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN)       ::  name
-
-    INTEGER(iwp)                       ::  i
-
-#if defined( __parallel )
-    INTEGER, DIMENSION(rd_status_size) ::  status
-#endif
-
-    LOGICAL                            ::  found
-
-    REAL(wp), INTENT(INOUT), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  data
+    CHARACTER(LEN=*), INTENT(IN)       ::  name    !<
+
+    INTEGER(iwp)                       ::  i       !<
+
+#if defined( __parallel )
+    INTEGER, DIMENSION(rd_status_size) ::  status  !<
+#endif
+
+    LOGICAL                            ::  found   !<
+
+    REAL(wp), INTENT(INOUT), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  data  !<
 
 
@@ -923,5 +969,5 @@
     IF ( found )  THEN
 #if defined( __parallel )
-       CALL sm_io%sm_node_barrier()  ! has no effect if I/O on limited number of cores is inactive
+       CALL sm_io%sm_node_barrier()  ! Has no effect if I/O on limited number of cores is inactive
        IF( sm_io%iam_io_pe )  THEN
           CALL MPI_FILE_SET_VIEW( fh, array_position, MPI_REAL, ft_3d, 'native', MPI_INFO_NULL,    &
@@ -968,17 +1014,17 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN)       ::  name
-
-    INTEGER(iwp)                       ::  i
-    INTEGER, INTENT(IN)                ::  nzb_soil
-    INTEGER, INTENT(IN)                ::  nzt_soil
-
-#if defined( __parallel )
-    INTEGER, DIMENSION(rd_status_size) ::  status
-#endif
-
-    LOGICAL                            ::  found
-
-    REAL(wp), INTENT(INOUT), DIMENSION(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg) ::  data
+    CHARACTER(LEN=*), INTENT(IN)       ::  name      !<
+
+    INTEGER(iwp)                       ::  i         !<
+    INTEGER, INTENT(IN)                ::  nzb_soil  !<
+    INTEGER, INTENT(IN)                ::  nzt_soil  !<
+
+#if defined( __parallel )
+    INTEGER, DIMENSION(rd_status_size) ::  status    !<
+#endif
+
+    LOGICAL                            ::  found     !<
+
+    REAL(wp), INTENT(INOUT), DIMENSION(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg) ::  data  !<
 
 
@@ -996,8 +1042,8 @@
 #if defined( __parallel )
        CALL rd_mpi_io_create_filetypes_3dsoil( nzb_soil, nzt_soil )
-       CALL sm_io%sm_node_barrier()  ! has no effect if I/O on limited number of cores is inactive
+       CALL sm_io%sm_node_barrier()  ! Has no effect if I/O on limited number of cores is inactive
        IF ( sm_io%iam_io_pe )  THEN
-          CALL MPI_FILE_SET_VIEW( fh, array_position, MPI_REAL, ft_3dsoil, 'native', MPI_INFO_NULL,&
-                                  ierr )
+          CALL MPI_FILE_SET_VIEW( fh, array_position, MPI_REAL, ft_3dsoil, 'native',               &
+                                  MPI_INFO_NULL, ierr )
           CALL MPI_FILE_READ_ALL( fh, array_3d_soil, SIZE( array_3d_soil ), MPI_REAL, status, ierr )
           CALL MPI_TYPE_FREE( ft_3dsoil, ierr )
@@ -1038,11 +1084,11 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN)   ::  name
-    CHARACTER(LEN=*), INTENT(OUT)  ::  text
-    CHARACTER(LEN=128)             ::  line
-
-    INTEGER(iwp)                   ::  i
-
-    LOGICAL                        ::  found
+    CHARACTER(LEN=*), INTENT(IN)  ::  name   !<
+    CHARACTER(LEN=*), INTENT(OUT) ::  text   !<
+    CHARACTER(LEN=128)            ::  line   !<
+
+    INTEGER(iwp)                  ::  i      !<
+
+    LOGICAL                       ::  found  !<
 
 
@@ -1077,9 +1123,9 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN) ::  name
-
-    INTEGER(iwp)                 ::  logical_as_integer
-
-    LOGICAL, INTENT(OUT)         ::  value
+    CHARACTER(LEN=*), INTENT(IN) ::  name                !<
+
+    INTEGER(iwp)                 ::  logical_as_integer  !<
+
+    LOGICAL, INTENT(OUT)         ::  value               !<
 
 
@@ -1100,7 +1146,7 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN)  ::  name
-
-    INTEGER(KIND=iwp), INTENT(IN) ::  value
+    CHARACTER(LEN=*), INTENT(IN)  ::  name   !<
+
+    INTEGER(KIND=iwp), INTENT(IN) ::  value  !<
 
 
@@ -1116,12 +1162,16 @@
 
 
-
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> To do: Description missing!
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE wrd_mpi_io_real( name, value )
 
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN) ::  name
-
-    REAL(wp), INTENT(IN)         ::  value
+    CHARACTER(LEN=*), INTENT(IN) ::  name   !<
+
+    REAL(wp), INTENT(IN)         ::  value  !<
 
 
@@ -1147,13 +1197,13 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN)       ::  name
-
-    INTEGER(iwp)                       ::  i
-
-#if defined( __parallel )
-    INTEGER, DIMENSION(rd_status_size) ::  status
-#endif
-
-    REAL(wp), INTENT(IN), DIMENSION(nysg:nyng,nxlg:nxrg)    :: data
+    CHARACTER(LEN=*), INTENT(IN)       ::  name    !<
+
+    INTEGER(iwp)                       ::  i       !<
+
+#if defined( __parallel )
+    INTEGER, DIMENSION(rd_status_size) ::  status  !<
+#endif
+
+    REAL(wp), INTENT(IN), DIMENSION(nysg:nyng,nxlg:nxrg) ::  data  !<
 
 
@@ -1168,5 +1218,5 @@
     IF ( include_total_domain_boundaries )  THEN
 !
-!--    Prepare Output with outer boundaries
+!--    Prepare output with outer boundaries
        DO  i = lb%nxl, lb%nxr
           array_2d(i,lb%nys:lb%nyn) = data(lb%nys-nbgp:lb%nyn-nbgp,i-nbgp)
@@ -1175,5 +1225,5 @@
     ELSE
 !
-!--    Prepare Output without outer boundaries
+!--    Prepare output without outer boundaries
        DO  i = nxl,nxr
           array_2d(i,lb%nys:lb%nyn) = data(nys:nyn,i)
@@ -1183,5 +1233,5 @@
 
 #if defined( __parallel )
-    CALL sm_io%sm_node_barrier()  ! has no effect if I/O on limited number of cores is inactive
+    CALL sm_io%sm_node_barrier()  ! Has no effect if I/O on limited number of cores is inactive
     IF ( sm_io%iam_io_pe )  THEN
        CALL MPI_FILE_SET_VIEW( fh, array_position, MPI_REAL, ft_2d, 'native', MPI_INFO_NULL, ierr )
@@ -1194,5 +1244,5 @@
 #endif
 !
-!-- Type conversion required, otherwise rigth hand side brackets are calculated assuming 4 byte INT.
+!-- Type conversion required, otherwise right hand side brackets are calculated assuming 4 byte INT.
 !-- Maybe a compiler problem.
     array_position = array_position + ( INT( lb%ny, KIND=rd_offset_kind ) + 1 ) *                  &
@@ -1212,13 +1262,13 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN)                  ::  name
-
-    INTEGER(iwp)                                  ::  i
-    INTEGER(iwp)                                  ::  j
-
-#if defined( __parallel )
-    INTEGER, DIMENSION(rd_status_size)            ::  status
-#endif
-    INTEGER(KIND=iwp), INTENT(IN), DIMENSION(:,:) ::  data
+    CHARACTER(LEN=*), INTENT(IN)                  ::  name    !<
+
+    INTEGER(iwp)                                  ::  i       !<
+    INTEGER(iwp)                                  ::  j       !<
+
+#if defined( __parallel )
+    INTEGER, DIMENSION(rd_status_size)            ::  status  !<
+#endif
+    INTEGER(KIND=iwp), INTENT(IN), DIMENSION(:,:) ::  data    !<
 
 
@@ -1231,5 +1281,5 @@
     header_array_index = header_array_index + 1
 
-    IF ( ( nxr-nxl + 1 + 2 * nbgp ) == SIZE( data, 2 ) )  THEN
+    IF ( ( nxr - nxl + 1 + 2 * nbgp ) == SIZE( data, 2 ) )  THEN
 !
 !--    Integer arrays with ghost layers are not implemented yet. These kind of arrays would be
